#include "Team.h"

using namespace std;


Team::Team(Worldmodel *World): world(World) 
{
  int i=0; int ifor;
  for (ifor=0; i < FORMATIONS; i++)
    for (i=0; i<12 ; i++)
      {
	NPos[ifor][i] = 0;
	SummePos[ifor][i] = Vector2d(0,0);
	SummePosSq[ifor][i] = Vector2d(0,0);
      }

  for (ifor=0; i < 2; i++)
    for (i=0; i<12 ; i++)
      {
	aNPos[ifor][i] = 0;
	aSummePos[ifor][i] = Vector2d(0,0);
	aSummePosSq[ifor][i] = Vector2d(0,0);
      }
  aCount=0;
  formation=0;
  afor=0;
};

void Team::CalcTeamCOG()
{
  int N=0;
  Vector2d TeamSum=Vector2d(0,0);
  Vector2d TeamSumSq=Vector2d(0,0);

  int i;
  for (i=0; i<12 ; i++)
    if ( (world->otherGoalieNo!=i) && (world->otherTeam[i].age < MAXAGE) )
      {
	N++;
	TeamSum   += world->otherTeam[i].pos;
	TeamSumSq += mulcomp( world->otherTeam[i].pos, world->otherTeam[i].pos );
      }

  if (N==0)
    return;

  //cerr << "TeamSum: " << TeamSum << " TeamSumSq: " << TeamSumSq << endl;
  TeamCOG = 1 /(double) N * TeamSum;
  TeamVar = 1 /(double) N * TeamSumSq -  mulcomp( TeamCOG, TeamCOG );
  //cerr << "TeamCOG: " << TeamCOG ;
  TeamVar.setX(sqrt(TeamVar.getX()));
  TeamVar.setY(sqrt(TeamVar.getY()));
  //cerr << " TeamVar: " << TeamVar << endl;
};

void Team::Update()
{
  CalcTeamCOG();

  if ( fabs(TeamVar.getX()) < 0.001 || fabs(TeamVar.getY()) < 0.001 )
    return;

  aCount++;
  if (aCount % FORMATIONINTERVALL ==0)
    {
      //delete old formation
      for (int i=0; i<12; i++)
	{
	  aNPos[afor][i] = 0;
	  aSummePos[afor][i] = Vector2d(0,0);
	  aSummePosSq[afor][i] = Vector2d(0,0);
	};
      //switch to other formation
      afor=1-afor;
    };

  int i;
  Vector2d scale = Vector2d( 1/TeamVar.getX(), 1/TeamVar.getY() );
  Vector2d dummy;
  for (i=0; i<12 ; i++)
    if ( (world->otherGoalieNo!=i) && (world->otherTeam[i].age < MAXAGE) )
      {
	NPos[formation][i]++;
	dummy = mulcomp( scale, world->otherTeam[i].pos - TeamCOG );
	
	//SummePos[formation][i]   += dummy;
	//SummePosSq[formation][i] += mulcomp( dummy, dummy );

	//upgrade temporary formations
	aNPos[0][i]++;
	aSummePos[0][i]   += dummy;
	aSummePosSq[0][i] += mulcomp( dummy, dummy );
	aNPos[1][i]++;
	aSummePos[1][i]   += dummy;
	aSummePosSq[1][i] += mulcomp( dummy, dummy );

	//calculate predicted positions
	/*
	if ( NPos[formation][i]>2)
	  { 
	    dummy =  1.0 / (double) NPos[formation][i] *SummePos[formation][i];
	    Pos[i] = mulcomp( TeamVar, dummy ) + TeamCOG;
	    PosVar[i] = mulcomp( TeamVar, 1.0 / (double) NPos[formation][i] * 
				 SummePosSq[formation][i] - 
				 mulcomp( dummy, dummy ) );
	    PosVar[i].setX( sqrt( PosVar[i].getX() ) );
	    PosVar[i].setY( sqrt( PosVar[i].getY() ) );
	  }
	*/
	if ( aNPos[afor][i]>2)
	  { 
	    dummy =  1.0 / (double) aNPos[afor][i] *aSummePos[afor][i];
	    aPos[i] = mulcomp( TeamVar, dummy ) + TeamCOG;
	    aPosVar[i] = mulcomp( TeamVar, 1.0 / (double) aNPos[afor][i] * 
				 aSummePosSq[afor][i] - 
				 mulcomp( dummy, dummy ) );
	    aPosVar[i].setX( sqrt( aPosVar[i].getX() ) );
	    aPosVar[i].setY( sqrt( aPosVar[i].getY() ) );
	  }

	  
      }

};

Vector2d Team::GetPos(int PlayerNo)
{
  if ( PlayerNo < 0 || PlayerNo > 11)
    {
      cerr << "Team::GetPos invalid player no : " << PlayerNo << endl;
      return Vector2d(0,0);
    };
  
  if ( NPos[formation][PlayerNo]<2 )
    return Vector2d(0,0);
  
  // cerr << "player : " << PlayerNo << " SummePos: " << SummePos[PlayerNo]
  //     << " NPos: " << NPos[PlayerNo] << endl;

  return ( Pos[PlayerNo] );
};

Vector2d Team::GetVar(int PlayerNo)
{
  if ( PlayerNo < 0 || PlayerNo > 11)
    {
      cerr << "Team::GetVar invalid player no : " << PlayerNo << endl;
      return Vector2d(0,0);
    };
  
  if ( NPos[formation][PlayerNo]<2 )
    return Vector2d(0,0);

  return ( PosVar[PlayerNo] );
};
Vector2d Team::GetaPos(int PlayerNo)
{
  if ( PlayerNo < 0 || PlayerNo > 11)
    {
      cerr << "Team::GetPos invalid player no : " << PlayerNo << endl;
      return Vector2d(0,0);
    };
  
  if ( NPos[formation][PlayerNo]<2 )
    return Vector2d(0,0);
  
  // cerr << "player : " << PlayerNo << " SummePos: " << SummePos[PlayerNo]
  //     << " NPos: " << NPos[PlayerNo] << endl;

  return ( aPos[PlayerNo] );
};

Vector2d Team::GetaVar(int PlayerNo)
{
  if ( PlayerNo < 0 || PlayerNo > 11)
    {
      cerr << "Team::GetVar invalid player no : " << PlayerNo << endl;
      return Vector2d(0,0);
    };
  
  if ( NPos[formation][PlayerNo]<2 )
    return Vector2d(0,0);

  return ( aPosVar[PlayerNo] );
};

void Team::GetDefensePlayer(int &player1, int &player2)
{
  double x1=-9999;
  double x2=-9999;
  player1=0;
  player2=0;

  for ( int i=0; i<12; i++)
    if (aNPos[afor][i]>2)
      if (x1<aPos[i].getX())
	{
	  //cerr << "x1<apos :" << x1 << "<" << aPos[i].getX() << endl; 
	  player2=player1;
	  x2=x1;
	  x1=aPos[i].getX();
	  player1=i;
      }
      else if (x2<aPos[i].getX())
	{
	  //cerr << "x2<apos :" << x2 << "<" << aPos[i].getX() << endl; 
	  player2=i;
	  x2=aPos[i].getX();
	};
};
  
  
