void
StandardSituationModule::doPenaltyShootOutOurSetup( void )
{
    bool turn(world->ourSide == SIDE_LEFT && world->penaltySide == SIDE_RIGHT ||
	      world->penaltySide == SIDE_LEFT && world->ourSide == SIDE_RIGHT);

    AdvSkills::TurtleCommand tcmd;

    Vector2d kickerPosLeft(-FIELD_LENGTH/2 + PENALTY_DIST_X
			   + BALL_SIZE + world->my.size,
			   0.0);

    if (turn) kickerPosLeft *= -1;

    if (iAmGoalie && ! (world->my.number == penaltyPlayer)) {

	Vector2d goaliePosLeft(-FIELD_LENGTH/2 - 1, PENALTY_AREA_WIDTH/2 + 1);

	if (turn) goaliePosLeft *= -1;

	tcmd = skills->goToPosition(goaliePosLeft, 0.5, max(world->my.stamina -
							    EFFORT_DEC_THR*STAMINA_MAX,		    
							    world->my.staminaIncMax));

    } else {
	
	if (penaltyPlayer == world->my.number) {

	    tcmd = skills->goToPosition(kickerPosLeft, 0.5, max(world->my.stamina -
								EFFORT_DEC_THR*STAMINA_MAX,
								world->my.staminaIncMax));

	} else {
	    Vector2d playerPosLeft;
	    playerPosLeft.setRadAng(CENTER_CIRCLE_R - world->my.size - 0.5,
			 (world->my.number - 1) * M_PI/20 + DEG_TO_RAD(135));

	    if (turn) playerPosLeft *= -1;

	    tcmd  = skills->goToPosition(playerPosLeft, 0.5, max(world->my.stamina -
								 EFFORT_DEC_THR*STAMINA_MAX,
								 world->my.staminaIncMax));
	}
    }

    if (tcmd.state != AdvSkills::TFINISHED)
	skills->exec(tcmd);
    else {
	AdvSkills::TurnCommand cmd = skills->turnTo(world->ball);
	if (cmd.state != AdvSkills::RFINISHED)
	    skills->exec(cmd);
	else
	    skills->noAction();
    }

    wantToTurnHead = true;
    thwish.lookAtBall(Grade::ABSOLUTE, VIEW_WIDTH_NARROW);
};

void
StandardSituationModule::doPenaltyShootOutTheirSetup( void )
{
    bool turn(world->ourSide == SIDE_LEFT && world->penaltySide == SIDE_RIGHT ||
	      world->penaltySide == SIDE_LEFT && world->ourSide == SIDE_RIGHT);

    AdvSkills::TurtleCommand tcmd;

    if (iAmGoalie) {
	Vector2d goaliePosLeft(-FIELD_LENGTH/2 + PENALTY_MAX_GOALIE_DIST_X 
			       - 0.5, 0.0);
	
	if (turn) goaliePosLeft *= -1;
	
	tcmd = skills->goToPosition(goaliePosLeft, 0.5, max(world->my.stamina -
							    EFFORT_DEC_THR*STAMINA_MAX,
							    world->my.staminaIncMax));

    } else {
	Vector2d playerPosLeft;
	playerPosLeft.setRadAng(CENTER_CIRCLE_R - world->my.size - 1,
			(world->my.number - 1) * M_PI/20 + DEG_TO_RAD(140));

	if (turn) playerPosLeft *= -1;

	tcmd  = skills->goToPosition(playerPosLeft, 0.5, max(world->my.stamina -
							     EFFORT_DEC_THR*STAMINA_MAX,
							     world->my.staminaIncMax));
    }

    if (tcmd.state != AdvSkills::TFINISHED)
	skills->exec(tcmd);
    else {
	AdvSkills::TurnCommand cmd;
	if (iAmGoalie)
	    cmd = skills->turn(Angle(-M_PI/2.0));
	else
	    cmd = skills->turnTo(world->ball);

	if (cmd.state != AdvSkills::RFINISHED)
	    skills->exec(cmd);
	else
	    skills->noAction();
    }

    wantToTurnHead = true;
    if (iAmGoalie)
	thwish.lookAtPos(Grade::ABSOLUTE, Vector2d(0.0, 0.0),
			 VIEW_WIDTH_NARROW);
    else
	thwish.lookAtBall(Grade::ABSOLUTE, VIEW_WIDTH_NARROW);
}

void
StandardSituationModule::doPenaltyShootOut( void )
{
    bool turn(world->ourSide == SIDE_LEFT && world->penaltySide == SIDE_RIGHT ||
	      world->penaltySide == SIDE_LEFT && world->ourSide == SIDE_RIGHT);

    srand(world->time);
    int rand( (rand()/(RAND_MAX + 1.0) < 0.5) ? 1 : -1);

    Vector2d target(-FIELD_LENGTH/2, rand*(GOAL_WIDTH/2-1.5));

    if (turn) target *= -1;

    if (penaltyPlayer == world->my.number) {
	AdvSkills::ExtKickCommand cmd = skills->kick(BALL_SPEED_MAX, target);

	if (cmd.state != AdvSkills::KRANGE) {

	    skills->exec(cmd);
	    
	}
	else
	    skills->noAction();
    } else
	skills->noAction();
};
